# -*- coding: utf-8 -*-
import unittest
import pyqualys


class TestAssetIP(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        cls.__instance = pyqualys.QualysAPI(username="abc",
                                            password="abc@1",
                                            host="https://qualys.com/")
        cls.__service = cls.__instance.service("vulnerability")
        cls.__service.FORMAT = "json"

    def test_01_add_ips(self):
        new_ips = {"host_ips": "11.10.10.1-11.10.10.255",
                   "comment": "test+IP"}
        expected_output = "The operation was successfully completed"
        response = self.__service.add_asset_ips(**new_ips)
        self.assertEqual(response['data']['RETURN'],
                         expected_output)

    def test_02_update_ips(self):
        new_ips = {"host_ips": "11.10.10.1-11.10.10.255",
                   "comment": "test+Update+IP"}
        expected_output = "The operation was successfully completed"
        response = self.__service.update_asset_ips(**new_ips)
        self.assertEqual(response['data']['RETURN'],
                         expected_output)

    def test_03_get_ips(self):
        expected_output = "IP_LIST"
        response = self.__service.get_asset_ips()
        self.assertIn(expected_output, response['data'])


if __name__ == '__main__':
    suite = unittest.TestLoader().loadTestsFromTestCase(TestAssetIP)
    unittest.TextTestRunner(verbosity=2).run(suite)
